package edu.dartmouth.cs.notifydemo;


import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;

public class NotifyActivity extends Activity {
	private static final String TAG = "NotifyActivity";
	private  Intent intent;

	@Override
	protected void onPause() {
		super.onPause();
		Log.d(TAG, "NotifyActivity:onPause()");
	}

	@Override
	protected void onStart() {
		super.onStart();
		Log.d(TAG, "NotifyActivity:onStart()");
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		Log.d(TAG, "NotifyActivity:onDestroy()");
	}

	@Override
	protected void onRestart() {
		super.onRestart();
		Log.d(TAG, "NotifyActivity:onRestart()");
	}

	@Override
	protected void onResume() {
		super.onResume();
		Log.d(TAG, "NotifyActivity:onResume()");
	}

	@Override
	protected void onStop() {
		super.onStop();
		Log.d(TAG, "NotifyActivity:onStop()");
	}

	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

		Log.d(TAG, "NotifyActivity:onCreate() Thread Name " + Thread.currentThread().getName()
				+ " ID " + Thread.currentThread().getId()
				+ " State " + Thread.currentThread().getState());



		setContentView(R.layout.main);
        Button buttonStartService = findViewById(R.id.startservice);
        Button buttonStopService = findViewById(R.id.stopservice);
        
        buttonStartService.setOnClickListener(new Button.OnClickListener(){
			@Override
			public void onClick(View arg0) {
				Log.d(TAG, "NotifyActivity:startService()");
				intent = new Intent(NotifyActivity.this, NotifyService.class);
				startService(intent);
			}});
        
        buttonStopService.setOnClickListener(new Button.OnClickListener(){

			@Override
			public void onClick(View arg0) {

				// There are two ways in this code to stop the service: 1) using stopService(intent)
				// which calls the service onDestroy; or 2) you can send broadcast to the service
				// which will call stopSelf() which in turn calls onDestroy(). So comment out one
				// method to play with the two methods.

				Log.d(TAG, "NotifyActivity:sendBroadcast(RQS_STOP_SERVICE) or stopService()");

				// First method of explicit stop on service

				// stopService(intent);

				// Second method of sending a broadcast to the service

				Intent intent = new Intent();
				intent.setAction(NotifyService.ACTION);
				intent.putExtra(NotifyService.STOP_SERVICE_BROADCAST_KEY, NotifyService.RQS_STOP_SERVICE);
				sendBroadcast(intent);

			}});
        
    }
}